>From 94985c929282c82e2f5a1efcd75f3ea3c37b7506 Mon Sep 17 00:00:00 2001
From: Ade Lee <alee@redhat.com>
Date: Fri, 6 Jul 2012 17:40:21 -0400
Subject: [PATCH 38/38] Modify web.xml to use new Application classes to
 bootstrap servers

---
 base/ca/shared/webapps/ca/WEB-INF/web.xml     |   10 +++++++++-
 base/kra/shared/webapps/kra/WEB-INF/web.xml   |   10 +++++++++-
 base/ocsp/shared/webapps/ocsp/WEB-INF/web.xml |   10 +++++++++-
 base/tks/shared/webapps/tks/WEB-INF/web.xml   |   10 +++++++++-
 4 files changed, 36 insertions(+), 4 deletions(-)

diff --git a/base/ca/shared/webapps/ca/WEB-INF/web.xml b/base/ca/shared/webapps/ca/WEB-INF/web.xml
index 692cb4898cfe2133307a6a7ce75dff418ec82834..f519d413b4f0197770bc0c279f2450b8a41545d6 100644
--- a/base/ca/shared/webapps/ca/WEB-INF/web.xml
+++ b/base/ca/shared/webapps/ca/WEB-INF/web.xml
@@ -1900,9 +1900,13 @@
                          <param-value> /agent/ca/doRevoke       </param-value> </init-param>
    </servlet>
 
+   <listener>
+      <listener-class> org.jboss.resteasy.plugins.server.servlet.ResteasyBootstrap </listener-class>
+   </listener>
+
    <context-param>
       <param-name>resteasy.scan</param-name>
-      <param-value>true</param-value>
+      <param-value>false</param-value>
    </context-param>
 
    <context-param>
@@ -1920,6 +1924,10 @@
    <servlet>
       <servlet-name>Resteasy</servlet-name>
       <servlet-class>org.jboss.resteasy.plugins.server.servlet.HttpServletDispatcher</servlet-class>
+      <init-param>
+         <param-name>javax.ws.rs.Application</param-name>
+         <param-value>com.netscape.ca.CertificateAuthorityApplication</param-value>
+      </init-param>
    </servlet>
    
 [PKI_OPEN_SEPARATE_PORTS_WEB_COMMENT]
diff --git a/base/kra/shared/webapps/kra/WEB-INF/web.xml b/base/kra/shared/webapps/kra/WEB-INF/web.xml
index c6e9934ebbcb4b325781cf5b47992d596974e7f4..1283a2bb43cbc0a3100faf6ea6ed47270c501cb0 100644
--- a/base/kra/shared/webapps/kra/WEB-INF/web.xml
+++ b/base/kra/shared/webapps/kra/WEB-INF/web.xml
@@ -756,9 +756,13 @@
                          <param-value> ee          </param-value> </init-param>
    </servlet>
 
+   <listener>
+      <listener-class> org.jboss.resteasy.plugins.server.servlet.ResteasyBootstrap </listener-class>
+   </listener>
+
    <context-param>
       <param-name>resteasy.scan</param-name>
-      <param-value>true</param-value>
+      <param-value>false</param-value>
    </context-param>
 
    <context-param>
@@ -776,6 +780,10 @@
    <servlet>
       <servlet-name>Resteasy</servlet-name>
       <servlet-class>org.jboss.resteasy.plugins.server.servlet.HttpServletDispatcher</servlet-class>
+      <init-param>
+         <param-name>javax.ws.rs.Application</param-name>
+         <param-value>com.netscape.kra.KeyRecoveryAuthorityApplication</param-value>
+      </init-param>
    </servlet>
 
 [PKI_OPEN_SEPARATE_PORTS_WEB_COMMENT]
diff --git a/base/ocsp/shared/webapps/ocsp/WEB-INF/web.xml b/base/ocsp/shared/webapps/ocsp/WEB-INF/web.xml
index e4ea799eb486e28b991a910ae57bda1e3510b27d..04dfa66fa1c47eafe860d2baf4eddde097661d1a 100644
--- a/base/ocsp/shared/webapps/ocsp/WEB-INF/web.xml
+++ b/base/ocsp/shared/webapps/ocsp/WEB-INF/web.xml
@@ -469,9 +469,13 @@
                          <param-value> ee          </param-value> </init-param>
    </servlet>
 
+   <listener>
+      <listener-class> org.jboss.resteasy.plugins.server.servlet.ResteasyBootstrap </listener-class>
+   </listener>
+
    <context-param>
       <param-name>resteasy.scan</param-name>
-      <param-value>true</param-value>
+      <param-value>false</param-value>
    </context-param>
 
    <context-param>
@@ -489,6 +493,10 @@
    <servlet>
       <servlet-name>Resteasy</servlet-name>
       <servlet-class>org.jboss.resteasy.plugins.server.servlet.HttpServletDispatcher</servlet-class>
+      <init-param>
+         <param-name>javax.ws.rs.Application</param-name>
+         <param-value>com.netscape.ocsp.OCSPAuthorityApplication</param-value>
+      </init-param>
    </servlet>
 
 [PKI_OPEN_SEPARATE_PORTS_WEB_COMMENT]
diff --git a/base/tks/shared/webapps/tks/WEB-INF/web.xml b/base/tks/shared/webapps/tks/WEB-INF/web.xml
index c3f7593c2ddf316dfb7996ec3a7077a3430c9901..39c45d430ae977bf5aa842861f7530e28306a1e0 100644
--- a/base/tks/shared/webapps/tks/WEB-INF/web.xml
+++ b/base/tks/shared/webapps/tks/WEB-INF/web.xml
@@ -338,9 +338,13 @@
                          <param-value> ee          </param-value> </init-param>
    </servlet>
 
+   <listener>
+      <listener-class> org.jboss.resteasy.plugins.server.servlet.ResteasyBootstrap </listener-class>
+   </listener>
+
    <context-param>
       <param-name>resteasy.scan</param-name>
-      <param-value>true</param-value>
+      <param-value>false</param-value>
    </context-param>
 
    <context-param>
@@ -358,6 +362,10 @@
    <servlet>
       <servlet-name>Resteasy</servlet-name>
       <servlet-class>org.jboss.resteasy.plugins.server.servlet.HttpServletDispatcher</servlet-class>
+      <init-param>
+         <param-name>javax.ws.rs.Application</param-name>
+         <param-value>com.netscape.tks.TKSAuthorityApplication</param-value>
+      </init-param>
    </servlet>
 
 [PKI_OPEN_SEPARATE_PORTS_WEB_COMMENT]
-- 
1.7.10.1