>From 8a41792b05e08b0437665bec307dd67fedaa9fc9 Mon Sep 17 00:00:00 2001
From: Ade Lee <alee@redhat.com>
Date: Fri, 3 Jan 2014 03:44:36 -0500
Subject: [PATCH 2/2] Patch to fix paths in default settings file

---
 debian/patches/fix-default-settings.diff | 63 ++++++++++++++++++++++++++++++++
 debian/patches/series                    |  1 +
 2 files changed, 64 insertions(+)
 create mode 100644 debian/patches/fix-default-settings.diff

diff --git a/debian/patches/fix-default-settings.diff b/debian/patches/fix-default-settings.diff
new file mode 100644
index 0000000000000000000000000000000000000000..af0d22555ab2416c0fce0511cfec59290ff173a5
--- /dev/null
+++ b/debian/patches/fix-default-settings.diff
@@ -0,0 +1,63 @@
+diff --git a/base/server/etc/default.cfg b/base/server/etc/default.cfg
+index b83fb14..8ac5f11 100644
+--- a/base/server/etc/default.cfg
++++ b/base/server/etc/default.cfg
+@@ -216,7 +216,7 @@ pki_enable_java_debugger=False
+ pki_enable_proxy=False
+ pki_proxy_http_port=80
+ pki_proxy_https_port=443
+-pki_security_manager=true
++pki_security_manager=false
+ pki_tomcat_server_port=8005
+ 
+ # Paths
+@@ -231,9 +231,9 @@ pki_cgroup_systemd_service_path=/sys/fs/cgroup/systemd/system/%(pki_systemd_serv
+ pki_cgroup_systemd_service=%(pki_cgroup_systemd_service_path)s/%(pki_instance_name)s
+ pki_cgroup_cpu_systemd_service_path=/sys/fs/cgroup/cpu\,cpuacct/system/%(pki_systemd_service)s
+ pki_cgroup_cpu_systemd_service=%(pki_cgroup_cpu_systemd_service_path)s/%(pki_systemd_service)s
+-pki_tomcat_bin_path=/usr/share/tomcat/bin
+-pki_tomcat_lib_path=/usr/share/tomcat/lib
+-pki_tomcat_systemd=/usr/sbin/tomcat
++pki_tomcat_bin_path=/usr/share/tomcat7/bin
++pki_tomcat_lib_path=/usr/share/tomcat7/lib
++pki_tomcat_systemd=/etc/init.d/tomcat7
+ pki_source_catalina_properties=%(pki_source_server_path)s/catalina.properties
+ pki_source_servercertnick_conf=%(pki_source_server_path)s/serverCertNick.conf
+ pki_source_server_xml=%(pki_source_server_path)s/server.xml
+@@ -276,15 +276,15 @@ pki_nsutil_jar_link=%(pki_tomcat_webapps_subsystem_webinf_lib_path)s/pki-nsutil.
+ # JAR paths
+ # These are used in the processing of pkispawn and are not supposed
+ # to be overwritten by user configuration files
+-pki_jss_jar=%(jni_jar_dir)s/jss4.jar
+-pki_symkey_jar=%(jni_jar_dir)s/symkey.jar
+-pki_apache_commons_collections_jar=/usr/share/java/apache-commons-collections.jar
+-pki_apache_commons_io_jar=/usr/share/java/apache-commons-io.jar
+-pki_apache_commons_lang_jar=/usr/share/java/apache-commons-lang.jar
+-pki_apache_commons_logging_jar=/usr/share/java/apache-commons-logging.jar
++pki_jss_jar=/usr/share/java/jss4.jar
++pki_symkey_jar=/usr/share/java/symkey.jar
++pki_apache_commons_collections_jar=/usr/share/java/commons-collections3.jar
++pki_apache_commons_io_jar=/usr/share/java/commons-io.jar
++pki_apache_commons_lang_jar=/usr/share/java/commons-lang.jar
++pki_apache_commons_logging_jar=/usr/share/java/commons-logging.jar
+ pki_commons_codec_jar=/usr/share/java/commons-codec.jar
+-pki_httpclient_jar=/usr/share/java/httpcomponents/httpclient.jar
+-pki_httpcore_jar=/usr/share/java/httpcomponents/httpcore.jar
++pki_httpclient_jar=/usr/share/java/httpclient.jar
++pki_httpcore_jar=/usr/share/java/httpcore.jar
+ pki_javassist_jar=/usr/share/java/javassist.jar
+ pki_jettison_jar=/usr/share/java/jettison.jar
+ pki_ldapjdk_jar=/usr/share/java/ldapjdk.jar
+@@ -303,9 +303,9 @@ pki_resteasy_jettison_provider_jar=%(resteasy_lib)s/resteasy-jettison-provider.j
+ pki_scannotation_jar=/usr/share/java/scannotation.jar
+ pki_tomcatjss_jar=/usr/share/java/tomcatjss.jar
+ pki_velocity_jar=/usr/share/java/velocity.jar
+-pki_xerces_j2_jar=/usr/share/java/xerces-j2.jar
+-pki_xml_commons_apis_jar=/usr/share/java/xml-commons-apis.jar
+-pki_xml_commons_resolver_jar=/usr/share/java/xml-commons-resolver.jar
++pki_xerces_j2_jar=/usr/share/java/xercesImpl.jar
++pki_xml_commons_apis_jar=/usr/share/java/xml-apis.jar
++pki_xml_commons_resolver_jar=/usr/share/java/xml-resolver.jar
+ pki_jss_jar_link=%(pki_tomcat_common_lib_path)s/jss4.jar
+ pki_symkey_jar_link=%(pki_tomcat_common_lib_path)s/symkey.jar
+ pki_apache_commons_collections_jar_link=%(pki_tomcat_common_lib_path)s/apache-commons-collections.jar
diff --git a/debian/patches/series b/debian/patches/series
index 5f4130bc19cd4c3d8f6d6138a2535b3d042503bf..eea3f8be4107512c46f48c864a71a84091223e27 100644
--- a/debian/patches/series
+++ b/debian/patches/series
@@ -1,2 +1,3 @@
 fix-include-paths.diff
 debian-support.diff
+fix-default-settings.diff
-- 
1.8.4.3